Subject: Re: bug#35484: GDM failing to start stumpwm after merge

From: Brett Gilio <[email-masked]>
Date: Mon, 29 Apr 2019 19:44:27 -0500

Timothy Sample writes:

> Hi Brett,
>
> [email-masked] writes:
>
>> On 29.04.2019 18:05, Timothy Sample wrote:
>>>
>>> After doing some testing in a VM, it looks like this is an issue
>>> with my
>>> recent commit: 8caa458953eeac783c73a0e5aaa72842fe3914c9.
>>>
>>> I added a placeholder desktop entry file, and even though I did my best
>>> to make it invisible, GDM is still selecting it.  (I tested GNOME and
>>> XFCE, but I guess they were preferred by GDM over the placeholder,
>>> whereas StumpWM is not.  Maybe the has to do with how the names are
>>> sorted.)
>
> This is exactly the problem.  To find a default session, it sorts the
> names of all the “.desktop” files it can find (using “g_strcmp0”), and
> picks the first.  Since we have “GNOME” < “XFCE” < “Fail” < “stumpwm”,
> my tests did not catch this error.
>
> I can think of two options for a fix before 1.0 (which is supposed to be
> tomorrow!).  The cute one is to just rename “Fail” to “~Fail”, on the
> expectation that this will come after most other names when sorted.  The
> ugly one is to patch GDM to exclude the placeholder file when looking
> for “.desktop” files, and then to select it instead of raising an error
> when it can’t find anything.
>
> My preference is for the ugly one, because the cute one feels like
> putting a silly hack on top of silly hack – it’s just a bit too much.
> I’ve attached a patch.  Thoughts?  (If I don’t hear anything, I will
> push it – it’s important that this works for 1.0).
>
>
> In the future, we should find a way to make GDM errors less
> catastrophic, but I doubt we could do that in a day (I certainly
> couldn’t)!
>
>> Thank you for looking into this Tim! I have gone back to SLiM for the
>> time being until it is fixed :).
>>
>> If anybody else is having this issue, going back to SLiM is really
>> easy, check out my commit for reference.
>>
>> https://github.com/brettgilio/guix-system/commit/64d389db13c2f78ee5c58af28c1639b098113c93
>
> Thanks for providing this.  Hopefully it helps anybody else having
> problems.
>
>
> -- Tim

I think the uglier version is more generic and less likely to cause
future errors. But, it is a matter of time. The uglier one is likely
going to be more terse.

Do you need any help on my end?

Brett Gilio